<template>
    <div class="mx-2">


        <div class="flex flex-wrap">
            <div class="w-full sm:w-1/2 md:w-1/3 lg:w-1/4 xl:w-1/5 mb-4 border">
                <h4 class="text-center">Каталог</h4>
                <div v-if="treeData.length">
                    <div v-for="category1 in treeData">
                    <span style="cursor: pointer" @click="toggle(category1)">
                        {{category1.children.length ? '+' : '-'}}
                        {{category1.name}}
                    </span>
                        <div v-show="false" :id="category1.id">
                            <div v-for="category2 in category1.children" class="ml-3">
                            <span style="cursor: pointer" @click="toggle(category2)">
                                 {{category2.children.length ? '+' : '-'}}
                                 {{category2.name}}
                                <!--({{category2.products.length}})-->
                            </span>
                                <div v-show="false" :id="category2.id">
                                    <div v-for="category3 in category2.children" class="ml-3">
                                    <span style="cursor: pointer" @click="toggle(category3)">
                                        {{category3.children.length ? '+' : '-'}}
                                        {{category3.name}}
                                        <!--({{category3.products.length}})-->
                                    </span>
                                        <div v-show="false" :id="category3.id">
                                            <div v-for="category4 in category3.children" class="ml-3">
                                            <span style="cursor: pointer" @click="toggle(category4)">
                                                {{category4.children.length ? '+' : '-'}}
                                                {{category4.name}}
                                                <!--({{category4.products.length}})-->
                                            </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="w-full sm:w-1/2 md:w-1/3 lg:w-1/4 xl:w-2/5 mb-4 border">
                <h4 class="text-center">Продукты</h4>
                <table class="w-full">
                    <thead class="bg-gray-700 text-white">
                    <tr>
                        <th class="w-2/4 text-center">Наименование</th>
                        <th class="w-1/5 text-center">Кол-во</th>
                        <th class="w-1/5 text-center">Сумма</th>
                        <th class="w-1/12">---</th>
                    </tr>
                    </thead>
                    <tbody>
                    <product-component v-for="product in category.products"
                                       :key="product.id"
                                       :product="product"
                                       :category="category"
                                       :basket="basket"
                                       @addCard="addCard">
                    </product-component>
                    </tbody>

                </table>
            </div>
            <div class="w-full sm:w-1/2 md:w-1/3 lg:w-1/4 xl:w-2/5 mb-4 border">
                <h4 class="text-center">Корзина</h4>

                <table class="w-full">
                    <thead class="bg-blue-500 text-white">
                    <tr>
                        <th class="w-2/4 text-center">Наименование</th>
                        <th class="w-1/5 text-center">Кол-во</th>
                        <th class="w-1/5 text-center">Сумма</th>
                        <th class="w-1/12">---</th>
                    </tr>
                    </thead>
                    <tbody>
                    <basket-product v-for="(item, index) in basket"
                                    :key="index"
                                    :item="item" @removeCard="removeCard(index)"
                    >

                    </basket-product>


                    </tbody>

                </table>

                <h5 class="float-right mt-6 mx-4">Общая сумма:{{sum}} сом</h5>
            </div>
        </div>


        <button v-if="basket.length"
                class="float-right bg-white hover:bg-gray-100 text-gray-800 font-semibold py-2 px-4 border border-gray-400 rounded shadow"
                @click="orderCreate">Печать
        </button>

    </div>
</template>

<script>

    import axios from 'axios'
    import CardMixin from "../Mixins/CardMixin";

    export default {

        data: function () {
            return {
                treeData: [],
                orderResultText: '',
                paid: false
            }
        },

        mixins: [CardMixin],

        methods: {
            toggle(category) {
                let id = category.id;
                let el = document.getElementById(id);
                this.category = category;

                if (el.style.display === 'none') {
                    el.style.display = 'inline';
                } else {
                    el.style.display = 'none';

                }
            },


            orderCreate() {
                axios.post('/api/create-order', {
                    basket: this.basket,
                    sum: this.sum,
                    paid: this.paid
                }).then(response => {
                    if (response.data.result) {
                        this.print(response.data.html)
                        this.basket = [];
                        this.category = [];
                    }
                });
            },

            print(html) {
                let gen = window.open(",'name,");
                gen.document.write(html);
                gen.document.close()
                gen.print()
                gen.close()
            }


        },

        created() {
            axios.get('/api/categories-tree')
                .then(response => {
                    this.treeData = response.data;
                });
        },
    }
</script>
